-- BagInfosToolTip.lua
-- written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

function ShowBIWindow()
	-- ( offsetX, offsetY, width, height, bubble side )
	x, y, w, h, bblTo = -5, -10, 250, 65, "left";
	mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	if w + mouseX > screenWidth then bblTo = "right"; x = w - 10; end
	if not TBTop then y = h + 5; end
	
	_G.ToolTipWin = Turbine.UI.Window();
	--_G.ToolTipWin:SetSize( w, h );
	--_G.ToolTipWin:SetZOrder( 1 );
	_G.ToolTipWin.xOffset = x;
	_G.ToolTipWin.yOffset = y;
	--_G.ToolTipWin:SetPosition( mouseX - x, mouseY - y);
	_G.ToolTipWin:SetVisible( true );

	BITTListBox = Turbine.UI.ListBox();
	BITTListBox:SetParent( _G.ToolTipWin );
	BITTListBox:SetZOrder( 1 );
	BITTListBox:SetPosition( 20, 17 );
	BITTListBox:SetWidth( 285 );
	BITTListBox:SetMaxItemsPerLine( 1 );
	BITTListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--BITTListBox:SetBackColor( Color["darkgrey"] ); --debug purpose

	BIRefreshListBox();

	ApplySkin();
end

function BIRefreshListBox()
	BITTListBox:ClearItems();
	BITTPosY = 35;
	
	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	local newt = {}
	for i, v in pairs(ITL) do newt[tonumber(i)] = v; end
	ITL = newt;

	if #ITL == 0 then
		local lblName = Turbine.UI.Label();
		lblName:SetParent( _G.ToolTipWin );
		--lblName:SetFont ( 12 );
		lblName:SetText( L["BINI"] );
		lblName:SetPosition( 0, 0 );
		lblName:SetSize( 210, 35 );
		lblName:SetForeColor( Color["green"] );
		lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		--lblName:SetBackColor( Color["red"] ); -- debug purpose

		BITTListBox:AddItem( lblName );

		BITTPosY = BITTPosY + 35;
	else
		for i = 1, #ITL do
			for k,v in pairs(ITL[i]) do
				BITTItemTot = 0;
				for ii = 1, size do
					local bFound = false;
					local item = backpack:GetItem( ii );
				
					if item ~= nil then
						local itemName = item:GetName();
					
						if itemName == k then
							bFound = true;
							
							--**v Control of all data v**
							local BITTCtr = Turbine.UI.Control();
							BITTCtr:SetParent( BITTListBox );
							BITTCtr:SetSize( BITTListBox:GetWidth(), 35 );
							BITTCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
							--BITTCtr:SetBackColor( Color["red"] ); -- Debug purpose
							--**^
	
							-- Item Background/Underlay/Shadow/Image
							local BITTitemBG = Turbine.UI.Control();
							BITTitemBG:SetParent( BITTCtr );
							BITTitemBG:SetSize( 32, 32 );
							BITTitemBG:SetPosition( 0, 2 );
							BITTitemBG:SetBackground(ITL[i][itemName].B);
							BITTitemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
							local BITTitemU = Turbine.UI.Control();
							BITTitemU:SetParent( BITTCtr );
							BITTitemU:SetSize( 32, 32 );
							BITTitemU:SetPosition( 0, 2 );
							BITTitemU:SetBackground(ITL[i][itemName].U);
							BITTitemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							local BITTitemS = Turbine.UI.Control();
							BITTitemS:SetParent( BITTCtr );
							BITTitemS:SetSize( 32, 32 );
							BITTitemS:SetPosition( 0, 2 );
							BITTitemS:SetBackground(ITL[i][itemName].S);
							BITTitemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							local BITTitem = Turbine.UI.Control();
							BITTitem:SetParent( BITTCtr );
							BITTitem:SetSize( 32, 32 );
							BITTitem:SetPosition( 0, 2 );
							BITTitem:SetBackground(ITL[i][itemName].I);
							BITTitem:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							BITTListBox:AddItem( BITTCtr );
							BITTListBox:SetHeight( BITTPosY );

							-- Item Quantity
							itemQTE = Turbine.UI.Label();
							itemQTE:SetParent( BITTCtr );
							itemQTE:SetSize( 32, 15 );
							itemQTE:SetPosition( -4, 16 );
							itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
							itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
							itemQTE:SetOutlineColor( Color["black"] );
							itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
							itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
							itemQTE:SetForeColor( Color["nicegold"] );
							--BITTItemTot = BITTItemTot + item:GetQuantity();
							--itemQTE:SetText( BITTItemTot );

							--Check the rest of bag for same item (in case user as multiple stack
							for ii = i+1, size do
								local sameitem = backpack:GetItem( ii );
			
								if sameitem ~= nil then
									if sameitem:GetName() == k then
										BITTItemTot = BITTItemTot + sameitem:GetQuantity();
										itemQTE:SetText( BITTItemTot );
									end
								end
							end
							--
							--itemQTE:SetText( "9999" ); -- Debuf purpose

							-- Item name
							itemsLbl = Turbine.UI.Label();
							itemsLbl:SetParent( BITTCtr );
							itemsLbl:SetSize( BITTListBox:GetWidth() - 35, 35 );
							itemsLbl:SetPosition( 37, 2 );
							itemsLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
							itemsLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
							itemsLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
							itemsLbl:SetForeColor( Color["white"] );
							itemsLbl:SetText( itemName );

							--Put item name & quantity to red if quantity is <= 10. Credit goes to Wicky71.
							if item:GetQuantity()<=10 then
								itemQTE:SetForeColor( Color["red"] );
								itemsLbl:SetForeColor( Color["red"] );
							end
		
							BITTPosY = BITTPosY + 35;
						end
						if bFound then break end
					end
				end
			end
		end
	end

	BITTListBox:SetHeight( BITTPosY );

	if #ITL == 0 then _G.ToolTipWin:SetSize( 250, BITTPosY - 5 );
	else _G.ToolTipWin:SetSize( 325, BITTPosY - 5 ); end

	if TBTop then _G.ToolTipWin:SetPosition( mouseX - x, mouseY - y);
	else _G.ToolTipWin:SetPosition( mouseX - x, mouseY - BITTPosY ); end
end