-- BagInfosWindow.lua
-- Written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

function frmBagInfosWindow()
	frmBI = true;
	wBagInfos = Turbine.UI.Lotro.Window();
	--wBagInfos = Turbine.UI.Lotro.GoldWindow();
	
	wBagInfos:SetSize( 390, 465 );
    wBagInfos:SetPosition( BIWLeft, BIWTop );
	wBagInfos:SetText( L["BIIL"] );
	wBagInfos:SetVisible( true );
	wBagInfos:SetWantsKeyEvents( true );
	--wBagInfos:SetZOrder( 2 );
	wBagInfos:Activate();

	wBagInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wBagInfos:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wBagInfos:SetVisible( not wBagInfos:IsVisible() );
		end
	end

	wBagInfos.MouseUp = function( sender, args )
		settings.BagInfos.L = string.format("%.0f", wBagInfos:GetLeft());
		settings.BagInfos.T = string.format("%.0f", wBagInfos:GetTop());
		BIWLeft, BIWTop = wBagInfos:GetPosition();
		SaveSettings( false );
	end

	wBagInfos.Closing = function( sender, args )
		wBagInfos = nil;
		frmBI = nil;
	end
	
	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( wBagInfos );
	lblBackPack:SetText( L["BIT"] );
	lblBackPack:SetPosition( 0, 35);
	lblBackPack:SetSize( wBagInfos:GetWidth() , 15 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( Color["green"] );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( wBagInfos );
	ListBoxBorder:SetPosition( 15, lblBackPack:GetHeight() + 40 );
	ListBoxBorder:SetSize( 354, 354 );
	ListBoxBorder:SetBackColor( Color["grey"] );
	ListBoxBorder:SetVisible( true );

	BIListBox = Turbine.UI.ListBox();
	BIListBox:SetParent( wBagInfos );
	BIListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	BIListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	BIListBox:SetMaxItemsPerLine( 1 );
	BIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	BIListBox:SetBackColor( Color["black"] );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( wBagInfos );
	ScrollBar:SetPosition( ListBoxBorder:GetWidth() + 15, ListBoxBorder:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetWidth( 10 );
	BIListBox:SetVerticalScrollBar( ScrollBar );

	-- **v Show used slot info in tooltip? v**
	BIUsedSlots = Turbine.UI.Lotro.CheckBox();
	BIUsedSlots:SetParent( wBagInfos );
	BIUsedSlots:SetPosition( 30, BIListBox:GetTop() + BIListBox:GetHeight() + 5 );
	BIUsedSlots:SetText( L["BIUsed"] );
	BIUsedSlots:SetSize( string.len(BIUsedSlots:GetText()) * 8.5, 20 );
	BIUsedSlots:SetChecked( BIUsed );
	BIUsedSlots:SetForeColor( Color["rustedgold"] );

	BIUsedSlots.CheckedChanged = function( sender, args )
		_G.BIUsed = BIUsedSlots:IsChecked();
		settings.BagInfos.U = _G.BIUsed;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^
	-- **v Show max slot in tooltip? v**
	BIMaxSlots = Turbine.UI.Lotro.CheckBox();
	BIMaxSlots:SetParent( wBagInfos );
	BIMaxSlots:SetPosition( 30, BIUsedSlots:GetTop() + BIUsedSlots:GetHeight() );
	BIMaxSlots:SetText( L["BIMax"] );
	BIMaxSlots:SetSize( string.len(BIMaxSlots:GetText()) * 8.5, 20 );
	BIMaxSlots:SetChecked( BIMax );
	BIMaxSlots:SetForeColor( Color["rustedgold"] );

	BIMaxSlots.CheckedChanged = function( sender, args )
		_G.BIMax = BIMaxSlots:IsChecked();
		settings.BagInfos.M = _G.BIMax;
		SaveSettings( false );
		UpdateBackpackInfos();
	end
	-- **^

	RefreshBackPack();
end

function RefreshBackPack()
	local itemsCtl = {};
	local itemsLbl = {};
	local DIitemBG, DIitemU, DIitemS, DIitem = {}, {}, {}, {};
	BIWitem = {};
	BIListBox:ClearItems();
	
	for i = 1, size do
		BIWitem[i] = backpack:GetItem( i );

		if BIWitem[i] ~= nil then
			-- GetMaxStackSize is deprecated
			if BIWitem[i]:GetMaxStackSize() > 1 then -- Only show stackable item
				BIWitem[i].Q = BIWitem[i]:GetQualityImageID();
				BIWitem[i].B = BIWitem[i]:GetBackgroundImageID();-- deprecated
				BIWitem[i].U = BIWitem[i]:GetUnderlayImageID();-- deprecated
				BIWitem[i].S = BIWitem[i]:GetShadowImageID();-- deprecated
				BIWitem[i].I = BIWitem[i]:GetIconImageID();-- deprecated
				BIWitem[i].Name = BIWitem[i]:GetName();

				-- Container for all infos
				itemsCtl[i] = Turbine.UI.Control();
				itemsCtl[i]:SetSize( BIListBox:GetWidth(), 35 );

				-- Item Background/Underlay/Shadow/BIWitem
				DIitemBG[i] = Turbine.UI.Control();
				DIitemBG[i]:SetParent( itemsCtl[i] );
				DIitemBG[i]:SetSize( 32, 32 );
				DIitemBG[i]:SetPosition( 2, 2 );
				DIitemBG[i]:SetBackground(BIWitem[i].B);
				DIitemBG[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
				DIitemU[i] = Turbine.UI.Control();
				DIitemU[i]:SetParent( itemsCtl[i] );
				DIitemU[i]:SetSize( 32, 32 );
				DIitemU[i]:SetPosition( 2, 2 );
				DIitemU[i]:SetBackground(BIWitem[i].U);
				DIitemU[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

				DIitemS[i] = Turbine.UI.Control();
				DIitemS[i]:SetParent( itemsCtl[i] );
				DIitemS[i]:SetSize( 32, 32 );
				DIitemS[i]:SetPosition( 2, 2 );
				DIitemS[i]:SetBackground(BIWitem[i].S);
				DIitemS[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

				DIitem[i] = Turbine.UI.Control();
				DIitem[i]:SetParent( itemsCtl[i] );
				DIitem[i]:SetSize( 32, 32 );
				DIitem[i]:SetPosition( 2, 2 );
				DIitem[i]:SetBackground(BIWitem[i].I);
				DIitem[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

				DIitem[i].MouseClick = function( sender, args )	itemsLbl[i].MouseClick(sender,args); end

				DIitem[i].MouseHover = function(sender, args) itemsLbl[i].MouseHover();	end

				DIitem[i].MouseLeave = function(sender, args) itemsLbl[i].MouseLeave(); end
		
				-- Item name
				itemsLbl[i] = Turbine.UI.Label();
				itemsLbl[i]:SetParent( itemsCtl[i] );
				itemsLbl[i]:SetSize( BIListBox:GetWidth() - 35, 33 );
				itemsLbl[i]:SetPosition( 36, 2 );
				itemsLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
				itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
				itemsLbl[i]:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
				itemsLbl[i]:SetForeColor( Color["white"] );
				itemsLbl[i]:SetText( BIWitem[i].Name );
				itemsLbl[i].Sel = false;

				itemsLbl[i].MouseClick = function( sender, args )
					if ( args.Button == Turbine.UI.MouseButton.Left ) then
						if not itemsLbl[i].Sel then
							itemsLbl[i].Sel = true;
							itemsLbl[i]:SetForeColor( Color["green"] );

							local tITL = {};
							tITL[itemsLbl[i]:GetText()] = {};
							tITL[itemsLbl[i]:GetText()].Q = BIWitem[i].Q;
							tITL[itemsLbl[i]:GetText()].B = BIWitem[i].B;
							tITL[itemsLbl[i]:GetText()].U = BIWitem[i].U;
							tITL[itemsLbl[i]:GetText()].S = BIWitem[i].S;
							tITL[itemsLbl[i]:GetText()].I = BIWitem[i].I;
							table.insert( ITL, tITL );
							
							SavePlayerItemTrackingList(ITL);

							--Check all listbox for itentical item name
							for ii = 1, size do
								if BIWitem[ii] ~= "zEmpty" then
									if ii ~= i then
										if itemsLbl[i]:GetText() == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["green"] ); itemsLbl[ii]:SetBackColor( Color["darkgrey"] ); itemsLbl[ii].Sel = true; end
									end
								end
							end
						else
							itemsLbl[i].Sel = false;
							itemsLbl[i]:SetForeColor( Color["white"] );

							local iFoundAt = 0;
							for ii = 1, #ITL do
								for k, v in pairs(ITL[ii]) do
									if k == itemsLbl[i]:GetText() then iFoundAt = ii; break end
								end
							end
						
							table.remove( ITL, iFoundAt );
							SavePlayerItemTrackingList(ITL)

							--Check all listbox for itentical item name
							for ii = 1, size do
								if BIWitem[ii] ~= "zEmpty" then
									if ii ~= i then
										if itemsLbl[i]:GetText() == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["white"] ); itemsLbl[ii]:SetBackColor( Color["black"] ); itemsLbl[ii].Sel = false; end
									end
								end
							end
						end
					end
				end

				itemsLbl[i].MouseHover = function(sender, args) itemsLbl[i]:SetBackColor( Color["lightgrey"] ); end

				itemsLbl[i].MouseLeave = function(sender, args)
					if itemsLbl[i].Sel then itemsLbl[i]:SetBackColor( Color["darkgrey"] ); else itemsLbl[i]:SetBackColor( Color["black"] ); end
				end

				BIListBox:AddItem( itemsCtl[i] );
			else
				BIWitem[i] = "zEmpty";
			end
		else
			BIWitem[i] = "zEmpty";
		end
	end

	for i = 1, #ITL do
		for k, v in pairs(ITL[i]) do
			for ii = 1, size do
				if BIWitem[ii] ~= "zEmpty" then --List box skip empty slot in bag but increment continue normally
					if k == itemsLbl[ii]:GetText() then itemsLbl[ii]:SetForeColor( Color["green"] ); itemsLbl[ii]:SetBackColor( Color["darkgrey"] ); itemsLbl[ii].Sel = true; end
				end
			end
		end
	end
end