-- DurabilityInfosWindow.lua
-- Written by Habna


SlotsBG = {"0x41007eed", "0x41007ef6", "0x41007ef7", "0x41007eef", "0x41007eee", "0x41007ee9", "0x41007ef0", "0x41007ef9", "0x41007ef8",
		"0x41007ef4", "0x41007ef3", "0x41007ef2", "0x41007ef1", "0x41007ef5", "0x41007efa", "0x41007eea", "0x41007eeb", "0x41007eec",
		"0x41007efb", "0x410e8680"};

SlotsText = {L["EWST1"], L["EWST2"], L["EWST3"], L["EWST4"], L["EWST5"], L["EWST6"], L["EWST7"], L["EWST8"], L["EWST9"],
		L["EWST10"], L["EWST11"], L["EWST12"], L["EWST13"], L["EWST14"], L["EWST15"], L["EWST16"], L["EWST17"],	L["EWST18"],
		L["EWST19"], L["EWST20"]};

function ShowDIWindow()
	iFound = 0;

	for i = 1, #itemEquip do
		for k,v in pairs(itemEquip[i]) do
			if itemEquip[i].ItemDurPts ~= 100 and itemEquip[i].WearState ~= 0 then
				iFound = iFound + 1; -- Count entry in item tracking list so we can calculate the height needed to set tooltip height
				break
			end
		end
	end
	
	if iFound == 0 then
		if TBLocale == "en" then w = 220;
		elseif TBLocale == "fr" then w = 240; 
		elseif TBLocale == "de" then w = 260; end
	elseif iFound == 1 then w = 315;
		else w = 592;
	end

	-- ( offsetX, offsetY, width, height, bubble side )
	local x, y, w, h, bblTo = -5, -10, w, 15+(math.ceil(iFound/2)*36)+37, "left";
	
	if iFound >=1 then
		mis, mts, nint = 0, 0, false;
		if not DIIcon then --If icon not showing then minus it's width
			mis=37;
			if iFound == 1 then w=w-mis;
			else w=w-(2*mis); end
		end
		if not DIText then --If item name not showing then minus it's width
			mts=248;
			if iFound == 1 then w=w-mts;
			else w=w-(2*mts); end
		end
		if not DIIcon and not DIText then w=210; h=80; nint=true; end
		if DIIcon and not DIText then if iFound > 10 then w=(10*32)+30 else w=(iFound*32)+30 end h=15+(math.ceil(iFound/10)*36)+37; end
	end

	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	if w + mouseX > screenWidth then bblTo = "right"; x = w - 10; end
	if not TBTop then y = h + 5; end
	
	_G.ToolTipWin = Turbine.UI.Window();
	_G.ToolTipWin:SetSize( w, h );
	--_G.ToolTipWin:SetZOrder( 1 );
	_G.ToolTipWin.xOffset = x;
	_G.ToolTipWin.yOffset = y;
	_G.ToolTipWin:SetPosition( mouseX - x, mouseY - y);
	_G.ToolTipWin:SetVisible( true );
	
	--**v Control of all durability infos v**
	local ADICtr = Turbine.UI.Control();
	ADICtr:SetParent( _G.ToolTipWin );
	ADICtr:SetZOrder( 1 );
	ADICtr:SetSize( w, h );
	ADICtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--ADICtr:SetBackColor( Color["red"] ); -- Debug purpose
	--**^

	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( ADICtr );
	lblBackPack:SetPosition( 15, 15 );
	if TBLocale == "de" and not DIIcon then lblBackPack:SetPosition( 10, 15 ); end
	lblBackPack:SetSize( 350, 15 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	lblBackPack:SetForeColor( Color["green"] );

	lblBackPackD = Turbine.UI.Label();
	lblBackPackD:SetParent( ADICtr );

	MaxFound = 4;
	if TBLocale == "fr" then MaxFound = 5; end
	if TBLocale == "de" then MaxFound = 6; end

	if iFound == 0 then
		lblBackPack:SetPosition( 15, 22 );
		lblBackPack:SetText( L["DWLblND"] );
	elseif iFound == 1 then
		if nint then
			lblBackPack:SetText( iFound .. L["DWLbl"] );
		else
			if DIText then lblBackPack:SetText( iFound .. L["DWLbl"] );
			else lblBackPack:SetText( iFound .. L["dmg"] ); end
		end
	else
		if nint then
			lblBackPack:SetText( iFound .. L["DWLbl"] );
		else
			if DIIcon and DIText or not DIIcon or DIText  then
				lblBackPack:SetText( iFound .. L["DWLbls"] );
			else
				if iFound >= MaxFound then
					lblBackPack:SetText( iFound .. L["DWLbls"] );
				else
					lblBackPack:SetText( iFound .. L["dmg"] );
				end
			end
		end
	end

	lblBackPackD:SetSize( 80, 15 );
	lblBackPackD:SetPosition( ADICtr:GetWidth() - lblBackPackD:GetWidth() - 15 , 15 );
	if TBLocale == "de" and not DIIcon then lblBackPackD:SetPosition( ADICtr:GetWidth() - lblBackPackD:GetWidth() - 10 , 15 ); end
	lblBackPackD:SetText( L["D"] );
	if iFound == 0 then lblBackPackD:SetVisible( false );
	else lblBackPackD:SetVisible( DIText ); end
	lblBackPackD:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	lblBackPackD:SetForeColor( Color["green"] ); 

	DIListBox = Turbine.UI.ListBox();
	DIListBox:SetParent( ADICtr );
	DIListBox:SetPosition( lblBackPack:GetLeft(), lblBackPack:GetTop() + lblBackPack:GetHeight() + 5 );
	--DIListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	MaxIPL=2;
	if DIIcon and not DIText then MaxIPL=10; end
	DIListBox:SetMaxItemsPerLine( MaxIPL );
	DIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	DIListBox:SetBackColor( Color["black"] );
	DIListBox:SetVisible( true );
	if iFound == 0 then DIListBox:SetVisible( false ); end

	DIRefreshListBox();

	ApplySkin();
end

function DIRefreshListBox()
	local DIitemCtl = {};
	local Lblnint = {};
	local DIitemLbl = {};
	local DIitemLblScore = {};
	local DIitemBG, DIitemU, DIitemS, DIitem = {}, {}, {}, {};
	DIListBox:ClearItems();
	x = 0;
	y = 1;
	
	if nint then
		--**v Control of all data v**
		local DICCtr = Turbine.UI.Control();
		DICCtr:SetParent( DIListBox );
		DICCtr:SetSize( 180, 35 );
		DICCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		--DICCtr:SetBackColor( Color["red"] ); -- Debug purpose
		--**^

		-- No icon & no text %
		local blnint = Turbine.UI.Label();
		blnint:SetParent( DICCtr );
		blnint:SetPosition( 0, 0 );
		blnint:SetSize( 180, DICCtr:GetHeight() );
		--blnint:SetForeColor( Color["white"] );
		blnint:SetText( L["DWnint"] );
		blnint:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		blnint:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		--blnint:SetBackColor( Color["blue"] ); -- Debug purpose

		DIListBox:AddItem( DICCtr );
		DIListBox:SetSize( 180, 35 );
	else
		for i = 1, 20 do
			if itemEquip[i].ItemDurPts ~= 100 and itemEquip[i].WearState ~= 0 then
				-- Item control
				DIitemCtl[i] = Turbine.UI.Control();
				DIitemCtl[i]:SetParent( DIListBox );
				DIitemCtl[i]:SetSize( 280-mis-mts, 36 );

				if DIIcon then
					-- Item Background/Underlay/Shadow/Item
					DIitemBG[i] = Turbine.UI.Control();
					DIitemBG[i]:SetParent( DIitemCtl[i] );
					DIitemBG[i]:SetSize( 32, 32 );
					DIitemBG[i]:SetPosition( 0, 2 );
					DIitemBG[i]:SetBackground(itemEquip[i].BImgID);
					DIitemBG[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
					DIitemU[i] = Turbine.UI.Control();
					DIitemU[i]:SetParent( DIitemCtl[i] );
					DIitemU[i]:SetSize( 32, 32 );
					DIitemU[i]:SetPosition( 0, 2 );
					DIitemU[i]:SetBackground(itemEquip[i].UImgID);
					DIitemU[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

					DIitemS[i] = Turbine.UI.Control();
					DIitemS[i]:SetParent( DIitemCtl[i] );
					DIitemS[i]:SetSize( 32, 32 );
					DIitemS[i]:SetPosition( 0, 2 );
					DIitemS[i]:SetBackground(itemEquip[i].SImgID);
					DIitemS[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

					DIitem[i] = Turbine.UI.Control();
					DIitem[i]:SetParent( DIitemCtl[i] );
					DIitem[i]:SetSize( 32, 32 );
					DIitem[i]:SetPosition( 0, 2 );
					DIitem[i]:SetBackground(itemEquip[i].IImgID);
					DIitem[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );
				end
				if DIText then
					-- Item name
					DIitemLbl[i] = Turbine.UI.Label();
					DIitemLbl[i]:SetParent( DIitemCtl[i] );
					DIitemLbl[i]:SetPosition( 37-mis, 0 );
					DIitemLbl[i]:SetSize( 208, DIitemCtl[i]:GetHeight() );
					DIitemLbl[i]:SetFont(Turbine.UI.Lotro.Font.TrajanPro12 );
					DIitemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
					--DIitemLbl[i]:SetForeColor( Color["white"] );
		
					if itemEquip[i].Item == false then 
						DIitemLbl[i]:SetForeColor( Color["red"] );
						DIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. L["EWItemNP"] );
					else
						DIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. itemEquip[i].Name );
					end

					-- Item Durability
					DIitemLblScore[i] = Turbine.UI.Label();
					DIitemLblScore[i]:SetParent( DIitemCtl[i] );
					DIitemLblScore[i]:SetPosition( 250-mis, 0 );
					DIitemLblScore[i]:SetText( itemEquip[i].ItemDurPts .. "%" );
					DIitemLblScore[i]:SetSize( 30, DIitemCtl[i]:GetHeight() );
					DIitemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
					DIitemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
				else
					if DIIcon then
						-- Item Durability (over the icon)
						DIitemLblScore[i] = Turbine.UI.Label();
						DIitemLblScore[i]:SetParent( DIitemCtl[i] );
						DIitemLblScore[i]:SetPosition( 0, 26 );
						DIitemLblScore[i]:SetSize( 30, 15 );
						DIitemLblScore[i]:SetText( itemEquip[i].ItemDurPts .. "%" );
						DIitemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.Verdana10 );
						DIitemLblScore[i]:SetFontStyle( Turbine.UI.FontStyle.Outline );
						DIitemLblScore[i]:SetOutlineColor( Color["black"] );
						DIitemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
						--DIitemLblScore[i]:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
					end
				end

				-- Show item
				DIListBox:AddItem( DIitemCtl[i] );
			
				x = x + 1;
				if x >= MaxIPL+1 then x = MaxIPL; end

				DIListBox:SetSize( DIitemCtl[i]:GetWidth()*x, math.ceil(iFound/MaxIPL)*36 );
				--DIListBox:SetBackColor( Color["blue"] ); -- Debug purpose
			end
		end
	end
end