-- MoneyInfosWindow.lua
-- written by Habna


function frmMoneyInfosWindow()
	frmMI = true;
	wMoneyInfos = Turbine.UI.Lotro.Window()
	--wMoneyInfos = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wMoneyInfos:SetText( L["MIWTitle"] );
	wMoneyInfos:SetWantsKeyEvents( true );
	wMoneyInfos:SetVisible( true );
	wMoneyInfos:SetWidth( 325 );
	--wMoneyInfos:SetZOrder( 2 );
	wMoneyInfos:Activate();

	wMoneyInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wMoneyInfos:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wMoneyInfos:SetVisible( not wMoneyInfos:IsVisible() );
		end
	end

	wMoneyInfos.MouseUp = function( sender, args )
		settings.Money.L = string.format("%.0f", wMoneyInfos:GetLeft());
		settings.Money.T = string.format("%.0f", wMoneyInfos:GetTop());
		MIWLeft, MIWTop = wMoneyInfos:GetPosition();
		SaveSettings( false );
	end

	wMoneyInfos.Closing = function( sender, args ) -- Function for the Upper right X icon
		wMoneyInfos = nil;
		frmMI = nil;
	end
	-- **^

	MIListBox = Turbine.UI.ListBox();
	MIListBox:SetParent( wMoneyInfos );
	MIListBox:SetPosition( 20, 35 );
	MIListBox:SetWidth( wMoneyInfos:GetWidth() - 40 );
	MIListBox:SetMaxItemsPerLine( 1 );
	MIListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--MIListBox:SetBackColor( Color["darkgrey"] ); --debug purpose
	
	-- **v Display total money - check box v**
	AllCharCB = Turbine.UI.Lotro.CheckBox();
	AllCharCB:SetParent( wMoneyInfos );
	AllCharCB:SetText( L["MIWAll"] );
	AllCharCB:SetSize( wMoneyInfos:GetWidth(), 30 );
	AllCharCB:SetChecked( _G.STM );
	AllCharCB:SetForeColor( Color["rustedgold"] );

	AllCharCB.CheckedChanged = function( sender, args )
		_G.STM = AllCharCB:IsChecked();
		settings.Money.S = _G.STM;
		SaveSettings( false );
		UpdateMoney();
	end
	-- **^
	-- **v Display character money - check box v**
	ThisCharCB = Turbine.UI.Lotro.CheckBox();
	ThisCharCB:SetParent( wMoneyInfos );
	ThisCharCB:SetText( L["MIWCM"] );
	ThisCharCB:SetSize( wMoneyInfos:GetWidth(), 30 );
	ThisCharCB:SetChecked( _G.SCM );
	ThisCharCB:SetForeColor( Color["rustedgold"] );

	ThisCharCB.CheckedChanged = function( sender, args )
		_G.SCM = ThisCharCB:IsChecked();
		if _G.STM then AllCharCB:SetChecked( false ); SaveCharacterMoney(); AllCharCB:SetChecked( true ); else SaveCharacterMoney(); end
		RefreshMIListBox();
	end
	-- **^
	-- **v Display to all character - check box v**
	ToAllCharCB = Turbine.UI.Lotro.CheckBox();
	ToAllCharCB:SetParent( wMoneyInfos );
	ToAllCharCB:SetText( L["MIWCMAll"] );
	ToAllCharCB:SetSize( wMoneyInfos:GetWidth(), 30 );
	ToAllCharCB:SetChecked( _G.SCMA );
	ToAllCharCB:SetForeColor( Color["rustedgold"] );

	ToAllCharCB.CheckedChanged = function( sender, args )
		_G.SCMA = ToAllCharCB:IsChecked();
		SaveCharacterMoney();
	end
	-- **^

	RefreshMIListBox();

	wMoneyInfos:SetPosition( MIWLeft, MIWTop );
end

function RefreshMIListBox()	
	MIListBox:ClearItems();
	MIPosY = 20;

	for k,v in pairs(wallet) do
		if k ~= "Total" then -- Skip Total in wallet table
			if k == Player:GetName() then
				if v.Show then
					MIShowData(k,v);				
				end
			else
				if v.ShowToAll or v.ShowToAll == nil then
					MIShowData(k,v);
				end
			end
		end
	end
	
	MIPosY = MIPosY + 10;

	--**v Line Control v**
	local LineCtr = Turbine.UI.Control();
	LineCtr:SetParent( MIListBox );
	LineCtr:SetSize( ListBox:GetWidth(), 10 );
	--LineCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );

	local LineLbl = Turbine.UI.Label();
	LineLbl:SetParent( LineCtr );
	LineLbl:SetText( "" );
	LineLbl:SetPosition( 0, 9 );
	LineLbl:SetSize( ListBox:GetWidth(), 1 );
	LineLbl:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	LineLbl:SetBackColor( Color["trueblue"] );

	MIListBox:AddItem( LineCtr );
	MIListBox:SetHeight( MIPosY );
	--**^
	
	--**v Control of total Gold/Silver/Copper v**
	local TotMoneyCtr = Turbine.UI.Control();
	TotMoneyCtr:SetParent( MIListBox );
	--TotMoneyCtr:SetPosition( 0, wMoneyInfos:GetWidth() );
	TotMoneyCtr:SetSize( MIListBox:GetWidth(), 20 );
	TotMoneyCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--TotMoneyCtr:SetBackColor( Color["red"] ); -- Debug purpose
	--**^
	--**v Total label v**
	local TotLbl = Turbine.UI.Label();
	TotLbl:SetParent( TotMoneyCtr );
	--TotLbl:SetFont ( 12 );
	TotLbl:SetText( L["MIWTotal"] );
	TotLbl:SetPosition( 21, 0 );
	TotLbl:SetSize( 65, 30 );
	TotLbl:SetForeColor( Color["white"] );
	TotLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--TotLbl:SetBackColor( Color["red"] ); -- debug purpose
	--**^
	--**v Copper icon & amount v**
	local CopperIcon = Turbine.UI.Control();
	CopperIcon:SetParent( TotMoneyCtr );
	CopperIcon:SetSize( 27, 21 );
	CopperIcon:SetPosition( TotMoneyCtr:GetWidth() - 30, 4 );
	CopperIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	CopperIcon:SetBackground( 0x41007e7d ); -- in-game copper icon
	--CopperIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local CopperLbl = Turbine.UI.Label();
	CopperLbl:SetParent( TotMoneyCtr );
	--CopperLbl:SetForeColor( Color["white"] );
	CopperLbl:SetText( string.format("%.0f", CopperTot) );
	CopperLbl:SetSize( 20, 30 );
	CopperLbl:SetPosition( CopperIcon:GetLeft() - 18, 0 );
	CopperLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	CopperLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--CopperLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^
	--**v Silver icon & amount v**
	local SilverIcon = Turbine.UI.Control();
	SilverIcon:SetParent( TotMoneyCtr );
	SilverIcon:SetSize( 27, 21 );
	SilverIcon:SetPosition( CopperLbl:GetLeft() - 34, 4 );
	SilverIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	SilverIcon:SetBackground( 0x41007e7c ); -- in-game silver icon
	--SilverIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local SilverLbl = Turbine.UI.Label();
	SilverLbl:SetParent( TotMoneyCtr );
	--SilverLbl:SetForeColor( Color["white"] );
	SilverLbl:SetText( string.format("%.0f", SilverTot) );
	SilverLbl:SetSize( 20, 30 );
	SilverLbl:SetPosition( SilverIcon:GetLeft() - 18, 0 );
	SilverLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SilverLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--SilverLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^
	--**v Gold icon & amount v**
	local GoldIcon = Turbine.UI.Control();
	GoldIcon:SetParent( TotMoneyCtr );
	GoldIcon:SetSize( 27, 21 );
	GoldIcon:SetPosition( SilverLbl:GetLeft() - 34, 4 );
	GoldIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	GoldIcon:SetBackground( 0x41007e7b ); -- in-game gold icon
	--GoldIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local GoldLbl = Turbine.UI.Label();
	GoldLbl:SetParent( TotMoneyCtr );
	--GoldLbl:SetForeColor( Color["white"] );
	GoldLbl:SetText( string.format("%.0f", GoldTot) );
	GoldLbl:SetSize( 50, 30 );
	GoldLbl:SetPosition( GoldIcon:GetLeft() - 48, 0 );
	GoldLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	GoldLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--GoldLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^
	
	MIListBox:AddItem( TotMoneyCtr );
	MIListBox:SetHeight( MIPosY );

	wMoneyInfos:SetHeight( MIListBox:GetHeight() + 130 );

	AllCharCB:SetPosition( 40, wMoneyInfos:GetHeight() - 75 );
	ThisCharCB:SetPosition( 40, wMoneyInfos:GetHeight() - 55 );
	ToAllCharCB:SetPosition( 40, wMoneyInfos:GetHeight() - 35 );
end

function MIShowData(k,v)
	--**v Control of Gold/Silver/Copper currencies v**
	local MoneyCtr = Turbine.UI.Control();
	MoneyCtr:SetParent( MIListBox );
	MoneyCtr:SetSize( MIListBox:GetWidth(), 20 );
	MoneyCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--MoneyCtr:SetBackColor( Color["red"] ); -- Debug purpose
	--**^
	--**v Delete icon v**
	local DelIcon = Turbine.UI.Label();
	DelIcon:SetParent( MoneyCtr );
	DelIcon:SetPosition( 0, 7 );
	DelIcon:SetSize(16, 16);
	DelIcon:SetBackground( resources.Del.Icon );
	DelIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	DelIcon:SetVisible( true );
	if k == Player:GetName() then DelIcon:SetVisible( false ); end
				
	DelIcon.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			write(k .. L["MIWID"]);
			--wallet[k].Show = false;
			wallet[k].ShowToAll = false;
			if _G.STM then AllCharCB:SetChecked( false ); SaveCharacterMoney(); AllCharCB:SetChecked( true ); else SaveCharacterMoney(); end
			RefreshMIListBox();
		end
	end
	--**^
	--**v Player name v**
	local lblName = Turbine.UI.Label();
	lblName:SetParent( MoneyCtr );
	--lblName:SetFont ( 12 );
	lblName:SetText( k );
	lblName:SetPosition( DelIcon:GetLeft() + DelIcon:GetWidth() + 5, 0 );
	lblName:SetSize( string.len(lblName:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	if k == Player:GetName() then lblName:SetForeColor( Color["green"] );
	else lblName:SetForeColor( Color["white"] ); end
	lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--lblName:SetBackColor( Color["red"] ); -- debug purpose
	--**^
	--**v Copper icon & amount v**
	local CopperIcon = Turbine.UI.Control();
	CopperIcon:SetParent( MoneyCtr );
	CopperIcon:SetSize( 27, 21 );
	CopperIcon:SetPosition( MoneyCtr:GetWidth() - 30, 4 );
	CopperIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	CopperIcon:SetBackground( 0x41007e7d ); -- in-game copper icon
	--CopperIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local CopperLbl = Turbine.UI.Label();
	CopperLbl:SetParent( MoneyCtr );
	--CopperLbl:SetForeColor( Color["white"] );
	CopperLbl:SetText( string.format("%.0f", v.Copper) );
	CopperLbl:SetSize(20, 30);
	CopperLbl:SetPosition( CopperIcon:GetLeft() - 18, 0 );
	CopperLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	CopperLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--CopperLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^
	--**v Silver icon & amount v**
	local SilverIcon = Turbine.UI.Control();
	SilverIcon:SetParent( MoneyCtr );
	SilverIcon:SetSize( 27, 21 );
	SilverIcon:SetPosition( CopperLbl:GetLeft() - 34, 4 );
	SilverIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	SilverIcon:SetBackground( 0x41007e7c ); -- in-game silver icon
	--SilverIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local SilverLbl = Turbine.UI.Label();
	SilverLbl:SetParent( MoneyCtr );
	--SilverLbl:SetForeColor( Color["white"] );
	SilverLbl:SetText( string.format("%.0f", v.Silver) );
	SilverLbl:SetSize(20, 30);
	SilverLbl:SetPosition( SilverIcon:GetLeft() - 18, 0 );
	SilverLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SilverLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--SilverLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^
	--**v Gold icon & amount v**
	local GoldIcon = Turbine.UI.Control();
	GoldIcon:SetParent( MoneyCtr );
	GoldIcon:SetSize( 27, 21 );
	GoldIcon:SetPosition( SilverLbl:GetLeft() - 34, 4 );
	GoldIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	GoldIcon:SetBackground( 0x41007e7b ); -- in-game gold icon
	--GoldIcon:SetBackColor( Color["blue"] ); -- Debug purpose
			
	local GoldLbl = Turbine.UI.Label();
	GoldLbl:SetParent( MoneyCtr );
	--GoldLbl:SetForeColor( Color["white"] );
	GoldLbl:SetText( string.format("%.0f", v.Gold) );
	GoldLbl:SetSize(50, 30);
	GoldLbl:SetPosition( GoldIcon:GetLeft() - 48, 0 );
	GoldLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	GoldLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--GoldLbl:SetBackColor( Color["white"] ); -- Debug purpose
	--**^

	MIListBox:AddItem( MoneyCtr );
	MIListBox:SetHeight( MIPosY );
		
	MIPosY = MIPosY + 20;
end