-- frmMain.lua
-- written by Habna


resources = {
	--TitanBar = { Background = AppRes.."background.tga" },

	Bubble_TopLeftCorner = { Background = AppRes.."bubble_top_left_corner.tga" },
	Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	Bubble_TopRightCorner = { Background = AppRes.."bubble_top_right_corner.tga" },

	Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },

	Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	Ring = { Icon = AppRes.."ring.tga" },
	Picker = { Background = AppRes.."picker.jpg" }, --Color picker picture (240px x 71px)

	Seal = { Icon = AppRes.."seal.tga" }, -- Removed when found in-game 32x32 icon

	RuneKeeper = { Icon = AppRes.."runekeeper.tga" }, -- Removed when found in-game icon
	RuneKeeper_Small = { Icon = AppRes.."runekeeper_small.tga" }, -- Removed when found in-game icon
	Warden = { Icon = AppRes.."warden.tga" }, -- Removed when found in-game icon
	Warden_Small = { Icon = AppRes.."warden_small.tga" }, -- Removed when found in-game icon
	Defiler = { Icon = AppRes.."defiler.tga" }, -- Removed when found in-game icon
	Defiler_Small = { Icon = AppRes.."defiler_small.tga" }, -- Removed when found in-game icon

	Del = { Icon = AppRes.."del.tga" } -- Removed when found in-game delete icon
};


function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^
	
	TB["win"] = Turbine.UI.Window();
	if TBTop then TB["win"]:SetPosition( 0, 0 );
	else TB["win"]:SetPosition( 0, screenHeight - TBHeight ); end
	TB["win"]:SetSize( screenWidth, TBHeight );
	--TB["win"]:SetBackground( resources.TitanBar.Background );
	TB["win"]:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--TB["win"]:SetMouseVisible( false ); -- If set to false, menu will not work.
	TB["win"]:SetWantsKeyEvents( true );
	--TB["win"]:SetZOrder( 10 );
	TB["win"]:SetVisible( true );

	
	--**v TitanBar event handlers v**
	TB["win"].KeyDown = function( sender, args )
		-- Hide TitanBar if F12 key is press or reposition UI
		if ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then 
			TB["win"]:SetVisible( not TB["win"]:IsVisible() );
			if not windowOpen then MouseHoverCtr:SetVisible( not MouseHoverCtr:IsVisible() ); end
		end
		--if ( args.Action == 268435635 ) then -- toggle HUD
	end

	TB["win"].MouseMove = function( sender, args )
		windowOpen = false;
		AutoHideCtr:SetWantsUpdates( true );
	end

	TB["win"].MouseLeave = function( sender, args )
		if Player:IsInCombat() and windowOpen and TBAutoHide ~= L["OPAHD"] then AutoHideCtr:SetWantsUpdates( true );
		elseif TBAutoHide == L["OPAHE"] then AutoHideCtr:SetWantsUpdates( true ); end
	end

	TB["win"].MouseClick = function( sender, args )
		TB["win"].MouseMove();

		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			_G.sFromCtr = "TitanBar";
			TitanBarMenu:ShowMenu();
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end
	--**

	MouseHoverCtr = Turbine.UI.Window();
	MouseHoverCtr:SetPosition( (TB["win"]:GetWidth() / 2) - 125 , TB["win"]:GetHeight() );
	MouseHoverCtr:SetSize( 250, 15 );
	--MouseHoverCtr:SetZOrder( 1 );
	--MouseHoverCtr:SetBackColor( Color["red"] ); --debug purpose
	MouseHoverCtr:SetBackground( 0x41007e8f ); --( 0x411044a2, 0x41007e2a, 0x41007e8f )

	MouseHoverCtr.MouseHover = function( sender, args )
		AutoHideCtr:SetWantsUpdates( true );
	end
	
	AutoHideCtr = Turbine.UI.Control();
	--AutoHideCtr:SetWantsUpdates( true ); --debug purpose
	AutoHideCtr.Update = function( sender, args )
		if windowOpen then
			if TBTop then --TB is at top
				if ( TB["win"]:GetTop() + TB["win"]:GetHeight() == 0 ) then
					AutoHideCtr:SetWantsUpdates( false );
					windowOpen = false;
					MouseHoverCtr:SetVisible( true );
					MouseHoverCtr:SetTop( TB["win"]:GetTop() + TB["win"]:GetHeight() );
				else
					TB["win"]:SetTop( TB["win"]:GetTop() - 1 );
				end
			else  --TB is at bottom
				if ( TB["win"]:GetTop() == screenHeight ) then
					AutoHideCtr:SetWantsUpdates( false );
					windowOpen = false;
					MouseHoverCtr:SetVisible( true );
					MouseHoverCtr:SetTop( TB["win"]:GetTop() - MouseHoverCtr:GetHeight() );
				else
					TB["win"]:SetTop( TB["win"]:GetTop() + 1 );
				end
			end
		else
			if TBTop then --TB is at top
				if ( TB["win"]:GetTop() == 0 ) then
					AutoHideCtr:SetWantsUpdates( false );
					windowOpen = true;
				else
					MouseHoverCtr:SetVisible( false );
					TB["win"]:SetTop( TB["win"]:GetTop() + 1 );
				end
			else --TB is at bottom
				if ( TB["win"]:GetTop() + TB["win"]:GetHeight() == screenHeight ) then
					AutoHideCtr:SetWantsUpdates( false );
					windowOpen = true;
				else
					MouseHoverCtr:SetVisible( false );
					TB["win"]:SetTop( TB["win"]:GetTop() - 1 );
				end
			end
		end
	end
	
	PlayerCurrency = {};
	PlayerCurrencyHandler = {};

	LoadPlayerWallet();
	LoadPlayerItemTrackingList();
	LoadPlayerProfile();

	if ShowProfile then opt_profile.Click(); end--TitanBar was reloaded because a profile need to be loaded
	if ShowOptions then opt_options.Click(); end--TitanBar was reloaded because a font need to be loaded

	if TBAutoHide == L["OPAHE"] then AutoHideCtr:SetWantsUpdates( true ); end --Auto hide if needed

	if PlayerAlign == 1 then
		LoadPlayerMoney();
		if PlayerWalletSize ~= nil or PlayerWalletSize ~= 0 then
			if ShowShards then ImportCtr( "SP" ); end
			if ShowSkirmishMarks then ImportCtr( "SM" ); end
			if ShowMedallions then ImportCtr( "MP" ); end
			if ShowSeals then ImportCtr( "SL" ); end
			if ShowCommendations then ImportCtr( "CP" ); end
		end
	else
		-- Disable Money, DP, Shard, SM, Medallion & Seal. (Infos not usefull in Monster Play)
		ShowMoney, ShowDestinyPoints, ShowShards, ShowSkirmishMarks, ShowMedallions, ShowSeals = false, false, false, false, false, false;
		if PlayerWalletSize ~= nil or PlayerWalletSize ~= 0 then
			if ShowCommendations then ImportCtr( "CP" ); end
		end
	end

	if ShowMoney then ImportCtr( "MI" ); end
	if ShowDestinyPoints then ImportCtr( "DP" ); end
	if ShowShards then import (AppCtrD.."Shards"); end --if ShowShards then ImportCtr( "SP" ); end  --Put back when wallet info are available before plugin load
	if ShowSkirmishMarks then import (AppCtrD.."SkirmishMarks"); end --if ShowSkirmishMarks then ImportCtr( "SM" ); end --Put back when wallet info are available before plugin load
	if ShowMedallions then import (AppCtrD.."Medallions"); end --if ShowMedallions then ImportCtr( "MP" ); end  --Put back when wallet info are available before plugin load
	if ShowSeals then import (AppCtrD.."Seals"); end --if ShowSeals then ImportCtr( "SL" ); end  --Put back when wallet info are available before plugin load
	if ShowCommendations then import (AppCtrD.."Commendations"); end --if ShowCommendations then ImportCtr( "CP" ); end  --Put back when wallet info are available before plugin load

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	ItemRemovedTimer = Turbine.UI.Control();
	
	ItemRemovedTimer.Update = function( sender, args )
		ItemRemovedTimer:SetWantsUpdates( false );
		UpdateBackpackInfos();
	end
	--**
	
	if ShowBagInfos then ImportCtr( "BI" );	end
	if ShowPlayerInfos then ImportCtr( "PI" ); end

	if PlayerAlign == 2 then ShowDurabilityInfos, ShowEquipInfos = false, false; end
	if ShowDurabilityInfos or ShowEquipInfos then
		GetEquipmentInfos();
		AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) if ShowEquipInfos then GetEquipmentInfos(); UpdateEquipsInfos(); end if ShowDurabilityInfos then GetEquipmentInfos(); UpdateDurabilityInfos(); end end);
		AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ItemUnEquippedTimer:SetWantsUpdates( true ); end); --Workaround
		--AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) if ShowEquipInfos then GetEquipmentInfos(); UpdateEquipsInfos(); end if ShowDurabilityInfos then GetEquipmentInfos(); UpdateDurabilityInfos(); end end);
	end
	if ShowDurabilityInfos then ImportCtr( "DI" ); end
	
	--**v Workaround for the ItemUnequipped that fire before the Equipment was updated (Turnine API issue) v**
	ItemUnEquippedTimer = Turbine.UI.Control();

	ItemUnEquippedTimer.Update = function( sender, args )
		if ShowEquipInfos then GetEquipmentInfos(); UpdateEquipsInfos(); end
		if ShowDurabilityInfos then GetEquipmentInfos(); UpdateDurabilityInfos(); end
		ItemUnEquippedTimer:SetWantsUpdates( false );
	end
	--**

	if ShowEquipInfos then ImportCtr( "EI" ); end
		
	if ShowPlayerLoc then ImportCtr( "PL" ); end
	if ShowGameTime then ImportCtr( "GT" ); end
	
	--**v Run these function at-starup only once, cause if TitanBar is loaded with in-game plugin manager some control does not update properly v**
	OneTimer = Turbine.UI.Control();
	
	if ShowShards or ShowSkirmishMarks or ShowEquipInfos or ShowDurabilityInfos then OneTimer:SetWantsUpdates( true ); NumSec = 0; Interval = 2; end
	if ShowProfile then OneTimer:SetWantsUpdates( false ); ShowProfile = false; end --TitanBar was reloaded because a profil was loaded
	if ShowOptions then OneTimer:SetWantsUpdates( false ); ShowOptions = false; end --TitanBar was reloaded because a font was loaded
	if LangChange then OneTimer:SetWantsUpdates( false ); settings.Language.C = false; SaveSettings( false ); end --TitanBar was reloaded because a language was loaded
	if TBReloaded then OneTimer:SetWantsUpdates( false ); settings.TitanBar.Z = false; SaveSettings( false ); end --TitanBar was reloaded
	
	OneTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentsecond = currentdate.Second;
		if _G.Debug then max = 6; else max = 21; end
		if NumSec < max then -- Run for 21 secs.
			if (oldsecond ~= currentsecond) then
				if Interval == 0 then
					if ShowEquipInfos or ShowDurabilityInfos then GetEquipmentInfos();
						if PlayerEquipment ~= nil then
							if ShowEquipInfos then UpdateEquipsInfos();	end
							if ShowDurabilityInfos then UpdateDurabilityInfos(); end
						end
					end

					if _G.Debug then write( "OneTimer: Interval" );	end

					Interval = 2;
				else
					Interval = Interval - 1;
				end
				
				oldsecond = currentsecond;
				NumSec = NumSec + 1;

				if _G.Debug then
					if NumSec <= 1 then seconds = "sec"; else seconds = "secs"; end
					write( "OneTimer: " .. NumSec .. " " .. seconds );
				end
			end
		else
			OneTimer:SetWantsUpdates( false );
		end
	end
	--**
	--**v Run these functions all the time v**
	AllTimer = Turbine.UI.Control();
	AllTimer:SetWantsUpdates( true );
	
	AllTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentminute = currentdate.Minute;
		local currentsecond = currentdate.Second;
		
		if (oldminute ~= currentminute) then
			if ShowGameTime then-- Until i found the minute Changed event or something similar
				if _G.ShowBT then UpdateGameTime("bt");
				elseif _G.ShowST then UpdateGameTime("st");
				else UpdateGameTime("gt") end
			end
			oldminute = currentminute;
		end
		
		--Detect if wallet size as change
		if (oldsecond ~= currentsecond) then
			if PlayerWallet:GetSize() ~= PlayerWalletSize then
				LoadPlayerWallet();
				if ShowShards then ImportCtr( "SP" ); end
				if ShowSkirmishMarks then ImportCtr( "SM" ); end
				if ShowMedallions then ImportCtr( "MP" ); end
				if ShowSeals then ImportCtr( "SL" ); end
				if ShowCommendations then ImportCtr( "CP" ); end
				oldsecond = currentsecond;
			end
		end
		
		--When player log out & log in with same character, the durability control show -1%
		--Because equipment info are not avail when re-login, weird!
		--if PlayerAlign == 1 and ShowDurabilityInfos then if DI["Lbl"]:GetText() == "-1%" then GetEquipmentInfos(); UpdateDurabilityInfos(); end end
	end
	--**
end